---------------------------------------------------------------------
--== Import ===--
---------------------------------------------------------------------

import "Turbine.Gameplay"
import "Turbine.UI"
import "Turbine.UI.Lotro"
import "Souru.WeaponAssist.Type"
import "Souru.WeaponAssist.Class"
import "Souru.WeaponAssist.UI"


---------------------------------------------------------------------
--==  ===--
---------------------------------------------------------------------

SaveFile = nil
Windows = {}
OptionsWindow = nil

me = Turbine.Gameplay.LocalPlayer.GetInstance()

equipment = me:GetEquipment()
backpack = me:GetBackpack()

---------------------------------------------------------------------
--== Basic Functions ===--
---------------------------------------------------------------------

function Save()

	Turbine.PluginData.Save(Turbine.DataScope.Character, "WeaponSaveFile", SaveFile)

end

function MoveWindows(bool)

	for i,window in ipairs(Windows) do
		window:SetMouseVisible(bool)
	end

end

function mysplit (inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        local t={}
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                table.insert(t, str)
        end
        return t
end

findalignment = function(number)
	if number == 1 then
		return Turbine.UI.ContentAlignment.TopLeft;
	elseif number == 2 then
		return Turbine.UI.ContentAlignment.TopCenter;
	elseif number == 3 then
		return Turbine.UI.ContentAlignment.TopRight;
	elseif number == 4 then
		return Turbine.UI.ContentAlignment.MiddleRight;
	elseif number == 5 then
		return Turbine.UI.ContentAlignment.MiddleCenter;
	elseif number == 6 then
		return Turbine.UI.ContentAlignment.MiddleLeft;
	elseif number == 7 then
		return Turbine.UI.ContentAlignment.BottomLeft;
	elseif number == 8 then
		return Turbine.UI.ContentAlignment.BottomCenter;
	elseif number == 9 then
		return Turbine.UI.ContentAlignment.BottomRight;
	end
end

findfont = function(number)
	if number == 1 then
		return Turbine.UI.Lotro.Font.Arial12;
	elseif number == 2 then
		return Turbine.UI.Lotro.Font.TrajanPro13;
	elseif number == 3 then
		return Turbine.UI.Lotro.Font.TrajanPro14;
	elseif number == 4 then
		return Turbine.UI.Lotro.Font.TrajanPro15;
	elseif number == 5 then
		return Turbine.UI.Lotro.Font.TrajanPro16;
	elseif number == 6 then
		return Turbine.UI.Lotro.Font.TrajanPro18;
	elseif number == 7 then
		return Turbine.UI.Lotro.Font.TrajanPro19;
	elseif number == 8 then
		return Turbine.UI.Lotro.Font.TrajanPro20;
	elseif number == 9 then
		return Turbine.UI.Lotro.Font.TrajanPro21;
	elseif number == 10 then
		return Turbine.UI.Lotro.Font.TrajanPro23;
	elseif number == 11 then
		return Turbine.UI.Lotro.Font.TrajanPro24;
	elseif number == 12 then
		return Turbine.UI.Lotro.Font.TrajanPro25;
	elseif number == 13 then
		return Turbine.UI.Lotro.Font.TrajanPro26;
	elseif number == 14 then
		return Turbine.UI.Lotro.Font.TrajanPro28;
	elseif number == 15 then
		return Turbine.UI.Lotro.Font.TrajanProBold16;
	elseif number == 16 then
		return Turbine.UI.Lotro.Font.TrajanProBold22;
	elseif number == 17 then
		return Turbine.UI.Lotro.Font.TrajanProBold24;
	elseif number == 18 then
		return Turbine.UI.Lotro.Font.TrajanProBold25;
	elseif number == 19 then
		return Turbine.UI.Lotro.Font.TrajanProBold30;
	elseif number == 20 then
		return Turbine.UI.Lotro.Font.TrajanProBold36;
	elseif number == 21 then
		return Turbine.UI.Lotro.Font.Verdana10;
	elseif number == 22 then
		return Turbine.UI.Lotro.Font.Verdana12;
	elseif number == 23 then
		return Turbine.UI.Lotro.Font.Verdana14;
	elseif number == 24 then
		return Turbine.UI.Lotro.Font.Verdana16;
	elseif number == 25 then
		return Turbine.UI.Lotro.Font.Verdana18;
	elseif number == 26 then
		return Turbine.UI.Lotro.Font.Verdana20;
	elseif number == 27 then
		return Turbine.UI.Lotro.Font.Verdana22;
	elseif number == 28 then
		return Turbine.UI.Lotro.Font.Verdana23;
	end
end

function RemoveWindow(index)

	for i=index, table.getn(SaveFile)-1, 1 do
	
		SaveFile[i] = SaveFile[i+1]
	
	end
	
	SaveFile[table.getn(SaveFile)] = nil
	Save()
	CreateWindows()

end

function RemoveItem(window, index)

	for i=index, table.getn(SaveFile[window])-1, 1 do
	
		SaveFile[window][i] = SaveFile[window][i+1]
	
	end
	
	SaveFile[window][table.getn(SaveFile[window])] = nil
	Save()
	CreateWindows()

end

function AddNewWindow()

	local index = table.getn(SaveFile)+1
	
	SaveFile[index] = {}
	SaveFile[index]["name"] = "Window"..index
	SaveFile[index]["visible"] = true
	SaveFile[index]["orientation"] = true
	SaveFile[index]["distance"] = 30
	SaveFile[index]["opacity"] = 0.8
	SaveFile[index]["frameSize"] = 5
	SaveFile[index]["left"] = 500
	SaveFile[index]["top"] = 500
	SaveFile[index]["size"] = 32 
	
	AddNewItemTo(index)

	return index

end

function SwapItem(window, index, newIndex)
	
	
	if newIndex >= 1 and newIndex <= table.getn(SaveFile[window]) then
		local temp = SaveFile[window][index]
		SaveFile[window][index] = SaveFile[window][newIndex]
		SaveFile[window][newIndex] = temp

		Save()
		CreateWindows()
		
		return true
	else
		Turbine.Shell.WriteLine("Swaping not possible.")
		
		return false
	end

end

function AddNewItemTo(window)

	local index = table.getn(SaveFile[window])+1

	SaveFile[window][index] = {}
	SaveFile[window][index]["name"] = "New Item"
	SaveFile[window][index]["text"] = ""
	SaveFile[window][index]["frameColor"] = {}	
	
	if index > 1 then
	
		SaveFile[window][index]["frameColor"]["R"] = SaveFile[window][index-1]["frameColor"]["R"]
		SaveFile[window][index]["frameColor"]["G"] = SaveFile[window][index-1]["frameColor"]["G"]
		SaveFile[window][index]["frameColor"]["B"] = SaveFile[window][index-1]["frameColor"]["B"]
		SaveFile[window][index]["changeType"] = SaveFile[window][index-1]["changeType"]
		SaveFile[window][index]["alignment"] = SaveFile[window][index-1]["alignment"]
		SaveFile[window][index]["font"] = SaveFile[window][index-1]["font"]
	
	else

		SaveFile[window][index]["frameColor"]["R"] = 1
		SaveFile[window][index]["frameColor"]["G"] = 1
		SaveFile[window][index]["frameColor"]["B"] = 1
		SaveFile[window][index]["changeType"] = false
		SaveFile[window][index]["alignment"] = 5
		SaveFile[window][index]["font"] = 20
		
	end

	Save()

	return index

end

function FindItem(name)

	local item

	for i=1, equipment:GetSize()-1, 1 do
	
		item = equipment:GetItem(i)
	
		if item ~= nil then
		
			if name == item:GetName() then
			
				return item,true
			
			end
		
		end
	
	end
	
	for i=1, backpack:GetSize()-1, 1 do
	
		item = backpack:GetItem(i)
	
		if item ~= nil then
		
			if name == item:GetName() then
			
				return item,false
			
			end
		
		end
	
	end
	
	return nil

end

function ClearWindows()
	
	for i,window in ipairs(Windows) do
		Windows[i]:Remove()
		Windows[i] = nil
	end
	
end

function CreateWindows()

	if table.getn(Windows) > 0 then
		ClearWindows()
	end

	for i,data in ipairs(SaveFile) do
		Windows[i] = UI.Window(data)
	end

end

---------------------------------------------------------------------
--== LoadIn  ===--
---------------------------------------------------------------------

if Turbine.PluginData.Load(Turbine.DataScope.Character, "WeaponSaveFile") ~= nil then

	SaveFile = Turbine.PluginData.Load(Turbine.DataScope.Character, "WeaponSaveFile")
	CreateWindows()

else

	SaveFile = {}
		
end


equipment.ItemUnequipped = function(sender, args)

	local name = equipment:GetItem(args.Index):GetName()
	
	for i,window in ipairs(SaveFile) do
	
		for j,icon in ipairs(window) do
	
			if icon["name"] == name then

				Windows[i].items[j]:EquipedChanged(false)
				
			end
	
		end
	
	end

end


equipment.ItemEquipped = function(sender, args)
	
	local name = equipment:GetItem(args.Index):GetName()
	
	for i,window in ipairs(SaveFile) do
	
		for j,icon in ipairs(window) do
	
			if icon["name"] == name then
			
				Windows[i].items[j]:EquipedChanged(true)
				
			end
	
		end
	
	end

	
end



---------------------------------------------------------------------
--== Chat-Comands  ===--
---------------------------------------------------------------------

command = Turbine.ShellCommand()

function command:Execute( _, str )
    if str == nil or string.len( str ) == 0 then
        return
    end

    local list  = { }
    local index = 1

    for word in str:gmatch( "%w+" ) do
        list[ index ] = word
        index = index + 1
    end

    local cmd = string.lower( list[ 1 ] )

    if cmd == "options" then
       
	   if OptionsWindow == UI.OptionsWindow() then
			
			OptionsWindow = UI.OptionsWindow()

	   end
	   
    elseif cmd == "reload" then
      
	  CreateWindows()
	  
    elseif table.getn(list) == 2 then

		if list[1] == "unload" then
		
			for i,window in ipairs(SaveFile) do
				if string.lower(window["name"]) == string.lower(list[2]) then
					window["visible"] = false
					Turbine.Shell.WriteLine("Window: ''"..list[2].."'' turned off.")
					 CreateWindows()
					 return
				end
			end
			
			Turbine.Shell.WriteLine( "Invalid Window Name: " .. string.lower(list[1]) )
		
		elseif list[1] == "load" then
		
			for i,window in ipairs(SaveFile) do
				if string.lower(window["name"]) == string.lower(list[2]) then
					window["visible"] = true
					Turbine.Shell.WriteLine("Window: ''"..list[2].."'' turned on.")
					 CreateWindows()
					 return
				end
			end
			
			Turbine.Shell.WriteLine( "Invalid Window Name: " .. list[1] )

		else
		
			Turbine.Shell.WriteLine( "Invalid command: " .. cmd )
		
		end
		
	else
        Turbine.Shell.WriteLine( "Invalid command: " .. cmd )
    end
end

Turbine.Shell.AddCommand( "wa", command )
Turbine.Shell.AddCommand( "weaponassist", command )

Turbine.Shell.WriteLine("WeaponAssist: usage: /wa [options][reload][load <windowname>][unload <windowname>]")
