
Icon = class( Turbine.UI.Control )

function Icon:Constructor(data, parent, size, left, top, frameSize)
	Turbine.UI.Control.Constructor( self )
	
	self.data = data
	self.item,self.equiped = FindItem(data["name"])
	
	self:SetParent(parent)
	self:SetPosition(left, top)
	self:SetSize(size+(2*frameSize), size+(2*frameSize))
	self:SetMouseVisible(false)	
	
	if self.item then

		self.frame = Turbine.UI.Control()
		self.frame:SetMouseVisible(false)	
		self.frame:SetParent(self)
		self.frame:SetSize(self:GetSize())
		self.frame:SetBackColor(Turbine.UI.Color(data["frameColor"]["R"],data["frameColor"]["G"],data["frameColor"]["B"]))
		self.frame:SetZOrder(1)
		
		self.iconBG = Turbine.UI.Control()
		self.iconBG:SetMouseVisible(false)	
		self.iconBG:SetParent(self)
		self.iconBG:SetPosition(frameSize,frameSize)
		self.iconBG:SetSize(32, 32)
		self.iconBG:SetBackground(self.item:GetBackgroundImageID())
		self.iconBG:SetStretchMode(1)
		self.iconBG:SetZOrder(2)
		
		self.iconShadow = Turbine.UI.Control()
		self.iconShadow:SetMouseVisible(false)	
		self.iconShadow:SetParent(self.iconBG)
		self.iconShadow:SetSize(32, 32)
		self.iconShadow:SetBlendMode(Turbine.UI.BlendMode.Overlay)
		self.iconShadow:SetBackground(self.item:GetShadowImageID())
		self.iconShadow:SetZOrder(3)
		
		self.icon = Turbine.UI.Control()
		self.icon:SetMouseVisible(false)	
		self.icon:SetParent(self.iconShadow)
		self.icon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
		self.icon:SetSize(32, 32)
		self.icon:SetBackground(self.item:GetIconImageID())
		self.icon:SetZOrder(4)
		
		self.text = Turbine.UI.Label()
		self.text:SetMouseVisible(false)	
		self.text:SetParent(self.icon)
		self.text:SetSize(28, 32)
		self.text:SetLeft(2)
		if data["font"] then
			self.text:SetFont(findfont(data["font"]))
		else
			self.text:SetFont(findfont(20))
		end
		if data["alignment"] then
			self.text:SetTextAlignment(findalignment(data["alignment"]))
		else
			self.text:SetFont(findalignment(5))
		end
		
		self.text:SetFontStyle(Turbine.UI.FontStyle.Outline)
		self.text:SetText(data["text"])
		self.text:SetZOrder(5)
		
		
		self.iconBG:SetSize(size, size)
			
		if data["changeType"] then
			self:SetVisible(self.equiped)
		else
			self.frame:SetVisible(self.equiped)
		end
				
	else
	
		Turbine.Shell.WriteLine("No item with the name: "..data["name"].." found in inventory or equipment.")
		
	end
	
end

function Icon:EquipedChanged(bool)

	if self.data["changeType"] then
		self:SetVisible(bool)
	else
		self.frame:SetVisible(bool)
	end

end

function Icon:Remove()

	self:SetVisible(false)

end
