OptionsWindow = class( Turbine.UI.Lotro.Window )

function OptionsWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self )
	
	self:SetSize(500,630)
	self:SetText("WeaponAssist")
	self:SetPosition(300,200)
	self:SetVisible(true)
	
	self.selectedWindow = 1
	self.selectedItem = 1
	
	self.move = Turbine.UI.Lotro.CheckBox()
	self.move:SetParent(self)
	self.move:SetPosition(30,50)
	self.move:SetSize(300,20)
	self.move:SetText(" Moveable")
	
	self.move.CheckedChanged = function(sender,args)
		MoveWindows(self.move:IsChecked())
	end
	
	self.reload = Turbine.UI.Lotro.Button()
	self.reload:SetParent(self)
	self.reload:SetPosition(350,50)
	self.reload:SetWidth(100)
	self.reload:SetText("Reload")
	
	self.reload.Click = function(sender,args)

		CreateWindows()
	
	end
	
	self.windowOptions = WindowOptionControl(self)
	self.itemOptions = ItemOptionControl(self)
	self.itemOptions:SetTop(self.windowOptions:GetHeight()+self.windowOptions:GetTop())
	
	self.accept = Turbine.UI.Lotro.Button()
	self.accept:SetParent(self)
	self.accept:SetPosition(350,self.itemOptions:GetTop()+self.itemOptions:GetHeight())
	self.accept:SetWidth(100)
	self.accept:SetText("Accept")
	
	self.accept.Click = function(sender,args)
	
		self.move:SetChecked(false)
		self:SaveChanges()
		CreateWindows()
		self.itemOptions:UpdateColor()
	
	end
	
	self:UpdateContent()
	
end


function OptionsWindow:SaveChanges()

	local colorList = mysplit(self.itemOptions.color:GetText(), ",")

	if table.getn(SaveFile) > 0 then

		SaveFile[self.selectedWindow]["name"] = self.windowOptions.rename:GetText()
		SaveFile[self.selectedWindow]["visible"] = self.windowOptions.visible:IsChecked()
		SaveFile[self.selectedWindow]["orientation"] = self.windowOptions.orientation:IsChecked()
		SaveFile[self.selectedWindow]["distance"] = tonumber(self.windowOptions.distance:GetText())
		SaveFile[self.selectedWindow]["opacity"] = tonumber(self.windowOptions.opacity:GetText())
		SaveFile[self.selectedWindow]["frameSize"] = tonumber(self.windowOptions.frame:GetText())
		SaveFile[self.selectedWindow]["size"] = tonumber(self.windowOptions.size:GetText()) 
		
		if table.getn(SaveFile[self.selectedWindow]) > 0 then
		
			SaveFile[self.selectedWindow][self.selectedItem]["name"] = self.itemOptions.quickslotLabel:GetText()
			SaveFile[self.selectedWindow][self.selectedItem]["text"] = self.itemOptions.text:GetText()

			if table.getn(colorList) == 3 then
				SaveFile[self.selectedWindow][self.selectedItem]["frameColor"]["R"] = (tonumber(colorList[1])/255)
				SaveFile[self.selectedWindow][self.selectedItem]["frameColor"]["G"] = (tonumber(colorList[2])/255)
				SaveFile[self.selectedWindow][self.selectedItem]["frameColor"]["B"] = (tonumber(colorList[3])/255)
			end
			
			SaveFile[self.selectedWindow][self.selectedItem]["alignment"] = self.itemOptions.selectAlignment:GetSelection()	
			SaveFile[self.selectedWindow][self.selectedItem]["font"] = self.itemOptions.selectFont:GetSelection()	
			SaveFile[self.selectedWindow][self.selectedItem]["changeType"] = self.itemOptions.changeType:IsChecked()	
			
			self.windowOptions.select:RemoveItem(self.selectedWindow)
			self.windowOptions.select:AddItem(SaveFile[self.selectedWindow]["name"], self.selectedWindow, self.selectedWindow)
			self.windowOptions.select:SetSelection(self.selectedWindow)

			self.itemOptions.select:RemoveItem(self.selectedItem)
			self.itemOptions.select:AddItem(SaveFile[self.selectedWindow][self.selectedItem]["name"], self.selectedItem, self.selectedItem)
			self.itemOptions.select:SetSelection(self.selectedItem)
		
		end
		
	end
		
	Save()

end

function OptionsWindow:UpdateContent()

	self.windowOptions:UpdateContent()
	self.itemOptions:UpdateContent()

end

WindowOptionControl = class( Turbine.UI.Control )

function WindowOptionControl:Constructor(parent)
	Turbine.UI.Control.Constructor( self )
	
	self:SetParent(parent)
	self:SetSize(500,200)
	self:SetTop(100)
	
	self.heading = Turbine.UI.Label()
	self.heading:SetParent(self)
	self.heading:SetSize(100,30)
	self.heading:SetPosition(30,0)
	self.heading:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.heading:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	self.heading:SetText("Window")
	
	self.select = LabelledComboBox(nil, nil, 160)
	self.select:SetParent(self)
	self.select:SetPosition(30,40)
	
	self.remove = Turbine.UI.Lotro.Button()
	self.remove:SetParent(self)
	self.remove:SetPosition(200,40)
	self.remove:SetWidth(70)
	self.remove:SetText("Remove")
	
	self.remove.Click = function()
	
		RemoveWindow(self:GetParent().selectedWindow)
		self:GetParent().selectedWindow = 1
		self:GetParent():UpdateContent()
	
	end
	
	self.new = Turbine.UI.Lotro.Button()
	self.new:SetParent(self)
	self.new:SetPosition(280,40)
	self.new:SetWidth(50)
	self.new:SetText("New")

	self.visible = Turbine.UI.Lotro.CheckBox()
	self.visible:SetParent(self)
	self.visible:SetPosition(350,40)
	self.visible:SetSize(150,20)
	self.visible:SetText(" Load")
	
	self.rename = Turbine.UI.Lotro.TextBox()
	self.rename:SetParent(self)
	self.rename:SetPosition(30,68)
	self.rename:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.rename:SetSize(160,25)
	
	self.orientation = Turbine.UI.Lotro.CheckBox()
	self.orientation:SetParent(self)
	self.orientation:SetPosition(30,100)
	self.orientation:SetSize(300,20)
	self.orientation:SetText(" Orientation (Checked = Vertical)")
	
	--SIZE
	
	self.size = Turbine.UI.Lotro.TextBox()
	self.size:SetParent(self)
	self.size:SetPosition(30,130)
	self.size:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.size:SetSize(50,25)
	self.size:SetText("")
	
	self.sizeLabel = Turbine.UI.Label()
	self.sizeLabel:SetParent(self)
	self.sizeLabel:SetPosition(90,130)
	self.sizeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.sizeLabel:SetSize(50,25)
	self.sizeLabel:SetText("Size")
	
	--FRAME
	
	self.frame = Turbine.UI.Lotro.TextBox()
	self.frame:SetParent(self)
	self.frame:SetPosition(30,165)
	self.frame:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.frame:SetSize(50,25)
	self.frame:SetText("")
	
	self.frameLabel = Turbine.UI.Label()
	self.frameLabel:SetParent(self)
	self.frameLabel:SetPosition(90,165)
	self.frameLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.frameLabel:SetSize(50,25)
	self.frameLabel:SetText("Frame")

	--DISTANCE
	
	self.distance = Turbine.UI.Lotro.TextBox()
	self.distance:SetParent(self)
	self.distance:SetPosition(160,130)
	self.distance:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.distance:SetSize(50,25)
	self.distance:SetText("")
	
	self.distanceLabel = Turbine.UI.Label()
	self.distanceLabel:SetParent(self)
	self.distanceLabel:SetPosition(220,130)
	self.distanceLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.distanceLabel:SetSize(60,25)
	self.distanceLabel:SetText("Spacing")
	
	--OPACITY
	
	self.opacity = Turbine.UI.Lotro.TextBox()
	self.opacity:SetParent(self)
	self.opacity:SetPosition(160,165)
	self.opacity:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.opacity:SetSize(50,25)
	self.opacity:SetText("")
	
	self.opacityLabel = Turbine.UI.Label()
	self.opacityLabel:SetParent(self)
	self.opacityLabel:SetPosition(220,165)
	self.opacityLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.opacityLabel:SetSize(50,25)
	self.opacityLabel:SetText("Opacity")
	
	self.new.Click = function(sender,args)
	
		self:GetParent():SaveChanges()
		CreateWindows()
	
		local value =  AddNewWindow()
		self:GetParent().selectedWindow = value
		self:GetParent():UpdateContent()
		
	end
end

function WindowOptionControl:FillSelected(value)

	self:GetParent().selectedWindow = value
	
	local window = SaveFile[value]
	
	self.rename:SetText(window["name"])
	self.visible:SetChecked(window["visible"])
	self.orientation:SetChecked(window["orientation"])
	self.size:SetText(window["size"])
	self.distance:SetText(window["distance"])
	self.frame:SetText(window["frameSize"])
	self.opacity:SetText(window["opacity"])
	
	self:GetParent().itemOptions:UpdateContent()

end

function WindowOptionControl:FillSelect()

	self.select:Clear()
	if table.getn(SaveFile) > 0 then
		for i,windows in ipairs(SaveFile) do
			self.select:AddItem(windows["name"],i,i)
		end
		
		self.select:SetSelection(self:GetParent().selectedWindow)
		self:FillSelected(self:GetParent().selectedWindow)
	end

end

function WindowOptionControl:UpdateContent()

	self:FillSelect()

end



ItemOptionControl = class( Turbine.UI.Control )

function ItemOptionControl:Constructor(parent)
	Turbine.UI.Control.Constructor( self )

	self:SetParent(parent)
	self:SetSize(500,270)

	self.heading = Turbine.UI.Label()
	self.heading:SetParent(self)
	self.heading:SetSize(100,30)
	self.heading:SetPosition(30,10)
	self.heading:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.heading:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	self.heading:SetText("Item")
	
	self.select = LabelledComboBox(nil, nil, 230)
	self.select:SetParent(self)
	self.select:SetPosition(30,50)
	
	self.remove = Turbine.UI.Lotro.Button()
	self.remove:SetParent(self)
	self.remove:SetPosition(270,50)
	self.remove:SetWidth(70)
	self.remove:SetText("Remove")
	
	self.remove.Click = function()
	
		RemoveItem(self:GetParent().selectedWindow, self:GetParent().selectedItem)
		self:GetParent().selectedItem = 1
		self:UpdateContent()
	
	end
	
	self.new = Turbine.UI.Lotro.Button()
	self.new:SetParent(self)
	self.new:SetPosition(350,50)
	self.new:SetWidth(50)
	self.new:SetText("New")
	
	self.quickslot = Turbine.UI.Lotro.Quickslot()
	self.quickslot:SetParent(self)
	self.quickslot:SetPosition(30,90)
	self.quickslot:SetSize(38,38)
	self.quickslot:SetBackColor(Turbine.UI.Color.White)
	
	self.quickslotLabel = Turbine.UI.Label()
	self.quickslotLabel:SetParent(self)
	self.quickslotLabel:SetPosition(90,98)
	self.quickslotLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.quickslotLabel:SetSize(170,25)
	
	self.changePosLabel = Turbine.UI.Label()
	self.changePosLabel:SetParent(self)
	self.changePosLabel:SetPosition(275,90)
	self.changePosLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
	self.changePosLabel:SetSize(200,25)
	self.changePosLabel:SetText("Change Position")
	
	self.posUp = Turbine.UI.Lotro.Button()
	self.posUp:SetParent(self)
	self.posUp:SetPosition(270,105)
	self.posUp:SetWidth(70)
	self.posUp:SetText("Up/Left")
	
	self.posUp.Click = function()
	
		local index = self:GetParent().selectedItem
		if SwapItem(self:GetParent().selectedWindow, index, index-1) then
			self:FillSelect(index-1)
		end
	end

	self.posDown = Turbine.UI.Lotro.Button()
	self.posDown:SetParent(self)
	self.posDown:SetPosition(350,105)
	self.posDown:SetWidth(80)
	self.posDown:SetText("Down/Right")	
	
	self.posDown.Click = function()
		
		local index = self:GetParent().selectedItem
		if SwapItem(self:GetParent().selectedWindow, index, index+1) then
			self:FillSelect(index+1)
		end
	
	end
	self.color = Turbine.UI.Lotro.TextBox()
	self.color:SetParent(self)
	self.color:SetPosition(30,150)
	self.color:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.color:SetSize(150,25)
	self.color:SetText("")
	
	self.colorSquare = Turbine.UI.Control()
	self.colorSquare:SetParent(self)
	self.colorSquare:SetPosition(190,150)
	self.colorSquare:SetSize(25,25)
	
	self.colorLabel = Turbine.UI.Label()
	self.colorLabel:SetParent(self)
	self.colorLabel:SetPosition(220,150)
	self.colorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.colorLabel:SetSize(100,25)
	self.colorLabel:SetText("Color(R,G,B)")
	
	self.text = Turbine.UI.Lotro.TextBox()
	self.text:SetParent(self)
	self.text:SetPosition(30,185)
	self.text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.text:SetSize(50,25)
	self.text:SetText("")
	
	self.textLabel = Turbine.UI.Label()
	self.textLabel:SetParent(self)
	self.textLabel:SetPosition(90,185)
	self.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.textLabel:SetSize(100,25)
	self.textLabel:SetText("Text")
	
	self.selectAlignment = LabelledComboBox(nil, nil, 160)
	self.selectAlignment:SetParent(self)
	self.selectAlignment:SetPosition(30,215)
	self.selectAlignment:AddItem("Top Left", 1)
	self.selectAlignment:AddItem("Top Center", 2)
	self.selectAlignment:AddItem("Top Right", 3)
	self.selectAlignment:AddItem("Middle Right", 4)
	self.selectAlignment:AddItem("Middle Center", 5)
	self.selectAlignment:AddItem("Middle Left", 6)
	self.selectAlignment:AddItem("Bottom Left", 7)
	self.selectAlignment:AddItem("Bottom Center", 8)
	self.selectAlignment:AddItem("Bottom Right", 9)
	
	self.selectFont = LabelledComboBox(nil, nil, 160)
	self.selectFont:SetParent(self)
	self.selectFont:SetPosition(200,215)
	self.selectFont:AddItem("Arial 12", 1);
	self.selectFont:AddItem("TrajanPro 13", 2);
	self.selectFont:AddItem("TrajanPro 14", 3);
	self.selectFont:AddItem("TrajanPro 15", 4);
	self.selectFont:AddItem("TrajanPro 16", 5);
	self.selectFont:AddItem("TrajanPro 18", 6);
	self.selectFont:AddItem("TrajanPro 19", 7);
	self.selectFont:AddItem("TrajanPro 20", 8);
	self.selectFont:AddItem("TrajanPro 21", 9);
	self.selectFont:AddItem("TrajanPro 23", 10);
	self.selectFont:AddItem("TrajanPro 24", 11);
	self.selectFont:AddItem("TrajanPro 25", 12);
	self.selectFont:AddItem("TrajanPro 26", 13);
	self.selectFont:AddItem("TrajanPro 28", 14);
	self.selectFont:AddItem("TrajanProBold 16", 15);
	self.selectFont:AddItem("TrajanProBold 22", 16);
	self.selectFont:AddItem("TrajanProBold 24", 17);
	self.selectFont:AddItem("TrajanProBold 25", 18);
	self.selectFont:AddItem("TrajanProBold 30", 19);
	self.selectFont:AddItem("TrajanProBold 36", 20);
	self.selectFont:AddItem("Verdana 10", 21);
	self.selectFont:AddItem("Verdana 12", 22);
	self.selectFont:AddItem("Verdana 14", 23);
	self.selectFont:AddItem("Verdana 16", 24);
	self.selectFont:AddItem("Verdana 18", 25);
	self.selectFont:AddItem("Verdana 20", 26);
	self.selectFont:AddItem("Verdana 22", 27);
	self.selectFont:AddItem("Verdana 23", 28);
	
	self.changeType = Turbine.UI.Lotro.CheckBox()
	self.changeType:SetParent(self)
	self.changeType:SetPosition(30,245)
	self.changeType:SetSize(400,30)
	self.changeType:SetText(" If checked you can't see the item when unequiped")
	
	self.new.Click = function(sender,args)

		self:GetParent():SaveChanges()
		CreateWindows()

		local value =  AddNewItemTo(self:GetParent().selectedWindow)
		self:GetParent().selectedItem = value
		self:FillSelect(value)
		
	end
	
	self.quickslot.ShortcutChanged = function()
		
		if self.quickslot:GetShortcut():GetType() == Turbine.UI.Lotro.ShortcutType.Item then
			self.quickslotLabel:SetText(self.quickslot:GetShortcut():GetItem():GetName())
		end
			
	end

end
	
function ItemOptionControl:FillSelected(value, sender)

	if sender == self.select then

		self:GetParent().selectedItem = value

		local item = SaveFile[self:GetParent().selectedWindow][value]
		
		self.quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut())
		
		if SaveFile[self:GetParent().selectedWindow]["orientation"] then
			self.posUp:SetText("Up")
			self.posDown:SetText("Down")
		else
			self.posUp:SetText("Left")
			self.posDown:SetText("Right")
		end
		
		self.quickslotLabel:SetText(item["name"])
		self.text:SetText(item["text"])
		self.color:SetText(math.floor(item["frameColor"]["R"]*255)..", "..math.floor(item["frameColor"]["G"]*255)..", "..math.floor(item["frameColor"]["B"]*255))
		self.colorSquare:SetBackColor(Turbine.UI.Color(item["frameColor"]["R"],item["frameColor"]["G"],item["frameColor"]["B"]))
		self.selectAlignment:SetSelection((item["alignment"]))
		self.selectFont:SetSelection((item["font"]))
		self.changeType:SetChecked(item["changeType"])
		
	end

end

function ItemOptionControl:FillEmpty()

	self:GetParent().selectedItem = -1
	
	self.quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut())
	self.quickslotLabel:SetText("")
	self.text:SetText("")
	self.color:SetText("")
	self.colorSquare:SetBackColor()
	self.changeType:SetChecked("")

end

function ItemOptionControl:FillSelect(selected)

	local window = self:GetParent().selectedWindow
	
	self.select:Clear()
	
	if table.getn(SaveFile) > 0 then
		if table.getn(SaveFile[window]) > 0 then
			
			self.select:Clear()
			for i,items in ipairs(SaveFile[window]) do
				self.select:AddItem(items["name"],i,i)
			end
			self:GetParent().selectedItem = selected
			self.select:SetSelection(selected)
			self:FillSelected(self:GetParent().selectedItem, self.select)
			
		else
		
			self:FillEmpty()
			
		end		
	end

end

function ItemOptionControl:UpdateContent()

	self:FillSelect(1)
	
end

function ItemOptionControl:UpdateColor()

	self.colorSquare:SetBackColor(Turbine.UI.Color(SaveFile[self:GetParent().selectedWindow][self:GetParent().selectedItem]["frameColor"]["R"],SaveFile[self:GetParent().selectedWindow][self:GetParent().selectedItem]["frameColor"]["G"],SaveFile[self:GetParent().selectedWindow][self:GetParent().selectedItem]["frameColor"]["B"]))

end










